<template>
  <div class="errorPage nuxt-error">
    <component
      :is="errorPage"
      :error="error" />
  </div>
</template>

<script>
import { createNamespacedHelpers } from 'vuex';
import { SHOW_AUTH_MODAL } from '~/assets/js/store/actionManager/mutation-types';

import Error401 from '~/components/redesign/errors/error-401';
import Error403 from '~/components/redesign/errors/error-403';
import Error404 from '~/components/redesign/errors/error-404';
import Error500 from '~/components/redesign/errors/error-500';

import SeoMixin from '~/assets/js/mixins/seo/base';
import SeoPageMixin from '~/assets/js/mixins/seo/pages/error';

const STORE_USER = createNamespacedHelpers('user');
const STORE_ACTION_MANAGER = createNamespacedHelpers('actionManager');

export default {
  name: 'Error',
  mixins: [SeoMixin, SeoPageMixin],
  layout: 'default',
  props: {
    error: {
      type: Object,
      default: () => {},
    },
  },
  computed: {
    ...STORE_USER.mapState(['auth']),
    errorPage() {
      switch (this.error.statusCode) {
        case 401:
          return Error401;
        case 403:
          return Error403;
        case 404:
          return Error404;
        default:
          return Error500;
      }
    },
    isCabinet() {
      return this.$route.path.includes('/cabinet');
    },
  },
  watch: {
    // TODO: Может имеет смысл вынести все что связанно с 401 в сам компонет 401
    auth(newVal) {
      if (newVal && (this.error.statusCode === 401 || this.isCabinet)) {
        window.location.reload();
      }
    },
  },
  mounted() {
    // TODO: Может имеет смысл вынести все что связанно с 401 в сам компонет 401
    if (this.error.statusCode === 401) {
      this.showAuthModal();
    }
  },
  methods: {
    ...STORE_ACTION_MANAGER.mapMutations({
      showAuthModal: SHOW_AUTH_MODAL,
    }),
  },
};
</script>

<style lang="postcss">
.errorPage {
  display: flex;
  align-items: flex-start;
  justify-content: center;
  min-height: 70vh;
  background-image: url("~assets/svg/redesign/bg-error.svg");
  background-repeat: no-repeat;
  background-position: center -6rem;

  & &-content {
    display: flex;
    flex-direction: column;
    align-items: center;
    justify-content: center;
    padding: 6rem 0;
    text-align: center;
  }

  & &-number {
    display: block;
    font-family: var(--font-heading);
    font-size: 6rem;
    font-weight: var(--font-weight-medium);
    line-height: 1;
  }

  & &-title {
    display: block;
    padding-bottom: 1rem;
    font-family: var(--font-heading);
    font-size: 4rem;
    font-weight: var(--font-weight-medium);
    line-height: 1.2;
  }

  & &-text {
    display: block;
    margin-right: auto;
    width: 100%;
    max-width: 47rem;
    text-align: left;

    .paragraph {
      padding-top: 1rem;
      font-size: 1.125rem;
    }
  }

  @media screen and (max-width: 980px) {
    min-width: 20rem;
    min-height: auto;
    background-position: -72rem -4rem;

    & &-content {
      padding: 1rem 1.25rem 4rem;
    }

    & &-number {
      order: 1;
      font-size: 4.5rem;
    }

    & &-title {
      order: 2;
      font-size: 1.25rem;
    }

    & &-text {
      order: 3;
      max-width: 100%;
      text-align: center;

      .paragraph {
        font-size: 0.875rem;
        line-height: 1.8;
      }
    }
  }
}
</style>
